import express from "express"
import cors from 'cors'
import path from 'path'
import process from 'process'
import moment from 'moment';
import cookieParser from 'cookie-parser';

import db from './db.js'

const app = express();
const PORT = 8080;

db.connectDB();

app.use(express.static(path.join(process.cwd(), '../frontend/build')));

app.use(cookieParser());
app.use(express.json());
app.use(express.urlencoded({ extended: false }));
app.use(
  cors({
    origin: 'http://localhost:3000',
    credentials: true,
  })
); //cors 설정을 한다..

app.listen(PORT, () => {
  console.log(`Listening on port ${PORT}`);
}); // 서버 실행


function b64_to_utf8( str ) {
  return decodeURIComponent(escape(window.atob( str )));
}

function encode_utf8(s) {
  return unescape(encodeURIComponent(s));
}

app.post('/login', (req, res) => {
	/*
	TODO: 토큰의 무결성 체크
	토큰이 이상이 없다면, 로그인/회원가입 로직을 수행 후 jwt 쿠키를 보낸다.
	*/
	const expires =  moment().add('2','m').toDate()
	res.cookie('jwt', JSON.stringify(req.body), {expires});
	
	//통과 못하면 에러를 뱉는다
	res.send(req.body.name);

});











